/***********************************************************************/
/*                                                                     */
/*                              Pio (C++)                              */
/*                                                                     */
/*                    Polyglot Input/Output Library                    */
/*                                                                     */
/*                  projet Estime, INRIA-Rocquencourt                  */
/*                                                                     */
/*  Copyright 2004-2011 INRIA.                                         */
/*  Institut National de Recherche en Informatique et en Automatique.  */
/*  All rights reserved. This file is distributed only by permission.  */
/*                                                                     */
/*  Estelle Marchand <Estelle.Marchand@inria.fr>                       */
/*                                                                     */
/***********************************************************************/

/********************************************************************************/
/*                                                                              */
/*                                  Pio (C++)                                   */
/*                                                                              */
/*                        Polyglot Input/Output Library                         */
/*                                                                              */
/*                      projet Estime, INRIA-Rocquencourt                       */
/*                                                                              */
/*  Copyright 2004-2011 INRIA.                                                  */
/*  Institut National de Recherche en Informatique et en Automatique.           */
/*  All rights reserved. This file is distributed only by permission.           */
/*                                                                              */
/*  Estelle Marchand <Estelle.Marchand@inria.fr>                                */
/*                                                                              */
/********************************************************************************/

/***********************************************************************/
/*                                                                     */
/*                              PIO (C++)                              */
/*                                                                     */
/*                    Polyglot Input/Output Library                    */
/*                                                                     */
/*                  projet Estime, INRIA-Rocquencourt                  */
/*                                                                     */
/*  Copyright 2005-2007 INRIA.                                         */
/*  Institut National de Recherche en Informatique et en Automatique.  */
/*  All rights reserved. This file is distributed only by permission.  */
/*                                                                     */
/*  Estelle Marchand <Estelle.Marchand@inria.fr>                       */
/*                                                                     */
/***********************************************************************/

/* $Id: matrix_type2.cpp,v 1.3 2011-02-23 17:43:29 fclement Exp $ */

#include "matrix_type2.hpp"

namespace io{

  Matrix_type2::Matrix_type2(int mm,int nn,int** & x):i(x){m=mm;n=nn;matrix_type2 = INT;}
  Matrix_type2::Matrix_type2(int mm,int nn,boolean** & x):b(x){m=mm;n=nn;matrix_type2 = BOOLEAN;}
  Matrix_type2::Matrix_type2(int mm,int nn,double** &x):d(x){
    m=mm;n=nn;
  
    matrix_type2 = FLOAT;
  
  }
  Matrix_type2::Matrix_type2(int mm,int nn,string** &x):s(x){m=mm;n=nn;matrix_type2 = STRING;}
  Matrix_type2::Matrix_type2(int mm,int nn,float_triple** &x):ft(x){
    m=mm;n=nn;
    
    matrix_type2 = FLOAT_TRIPLE;
   
  }
  Matrix_type2::Matrix_type2(int mm,int nn,float_couple** &x):fc(x){
    m=mm;n=nn;
   
    matrix_type2 = FLOAT_COUPLE;
    
  }
  Matrix_type2::Matrix_type2(int mm,int nn,int_triple** &x):it(x){m=mm;n=nn;matrix_type2 = INT_TRIPLE;}
  Matrix_type2::Matrix_type2(int mm,int nn,int_couple** &x):ic(x){m=mm;n=nn;matrix_type2 = INT_COUPLE;}
  Matrix_type2::~Matrix_type2(){}
  Single_type Matrix_type2::type() const{return matrix_type2;}
  
  void Matrix_type2::free(){
  switch(matrix_type2){
  case INT:
    for(int ii=0; ii<m; ii++)
      delete[] i.data()[ii];
    delete[] i.data();
    break;
  case BOOLEAN:
    for(int ii=0; ii<m; ii++)
      delete[] b.data()[ii];
    delete[] b.data();
    break;
  case FLOAT:
    for(int ii=0; ii<m; ii++)
      delete[] d.data()[ii];
    delete[] d.data();
    break;
  case STRING:
    for(int ii=0; ii<m; ii++)
      delete[] s.data()[ii];
    delete[] s.data();
    break;
  case FLOAT_TRIPLE:
    for(int ii=0; ii<m; ii++)
      delete[] ft.data()[ii];
    delete[] ft.data();
    break;
  case FLOAT_COUPLE:
    for(int ii=0; ii<m; ii++)
      delete[] fc.data()[ii];
    delete[] fc.data();
    break;
  case INT_TRIPLE:
    for(int ii=0; ii<m; ii++)
      delete[] it.data()[ii];
    delete[] it.data();
    break;
  case INT_COUPLE:
    for(int ii=0; ii<m; ii++)
      delete[] ic.data()[ii];
    delete[] ic.data();
    break;
  default:
    ;
  }
  }

}
