/***********************************************************************/
/*                                                                     */
/*                              Pio (C++)                              */
/*                                                                     */
/*                    Polyglot Input/Output Library                    */
/*                                                                     */
/*                  projet Estime, INRIA-Rocquencourt                  */
/*                                                                     */
/*  Copyright 2004-2011 INRIA.                                         */
/*  Institut National de Recherche en Informatique et en Automatique.  */
/*  All rights reserved. This file is distributed only by permission.  */
/*                                                                     */
/*  Estelle Marchand <Estelle.Marchand@inria.fr>                       */
/*                                                                     */
/***********************************************************************/

/********************************************************************************/
/*                                                                              */
/*                                  Pio (C++)                                   */
/*                                                                              */
/*                        Polyglot Input/Output Library                         */
/*                                                                              */
/*                      projet Estime, INRIA-Rocquencourt                       */
/*                                                                              */
/*  Copyright 2004-2011 INRIA.                                                  */
/*  Institut National de Recherche en Informatique et en Automatique.           */
/*  All rights reserved. This file is distributed only by permission.           */
/*                                                                              */
/*  Estelle Marchand <Estelle.Marchand@inria.fr>                                */
/*                                                                              */
/********************************************************************************/

/***********************************************************************/
/*                                                                     */
/*                              PIO (C++)                              */
/*                                                                     */
/*                    Polyglot Input/Output Library                    */
/*                                                                     */
/*                  projet Estime, INRIA-Rocquencourt                  */
/*                                                                     */
/*  Copyright 2005-2007 INRIA.                                         */
/*  Institut National de Recherche en Informatique et en Automatique.  */
/*  All rights reserved. This file is distributed only by permission.  */
/*                                                                     */
/*  Estelle Marchand <Estelle.Marchand@inria.fr>                       */
/*                                                                     */
/***********************************************************************/

/* $Id: typed_value.cpp,v 1.3 2011-02-23 17:43:29 fclement Exp $ */

#include "typed_value.hpp"
#include "boolean.hpp"

namespace io{

  //Typed_value:
  Typed_value_type Typed_value::type(){return typed_value_type;}
  
  //constructeurs:
  Typed_value::Typed_value(const Lexem& x):
    scalar(x){
    typed_value_type=LEXEM;
  }
  
  Typed_value::Typed_value(const Vector_type& x):
    vect(x){
    typed_value_type=VECTOR;
  }
  
  Typed_value::Typed_value(const Matrix_type1& x):
    matrix1(x){
    typed_value_type=MATRIX1;
  }
  
  Typed_value::Typed_value(const Matrix_type2& x):
    matrix2(x){
    typed_value_type=MATRIX2;
  }
  
  //destructeurs:
  Typed_value::~Typed_value(){}
  
  //convertisseurs:
  Lexem & Typed_value::to_Lexem(){
    return scalar.data();
  }
  
  Matrix_type1 & Typed_value::to_Matrix_type1(){
    return matrix1.data();
  }
  
  Matrix_type2 & Typed_value::to_Matrix_type2(){
    return matrix2.data();
  }
  
  Vector_type & Typed_value::to_Vector_type(){
    return vect.data();
  }
  
  int & Typed_value::to_int(){
    return to_Lexem().to_int();
  }
  
  double & Typed_value::to_float(){
    return to_Lexem().to_float();
  }
  
  string & Typed_value::to_string(){
    return to_Lexem().to_string();
  }
  
  boolean & Typed_value::to_boolean(){
    return to_Lexem().to_boolean();
  }
  
  int_couple & Typed_value::to_int_couple(){
    return to_Lexem().to_int_couple();
  }
  
  int_triple & Typed_value::to_int_triple(){
    return to_Lexem().to_int_triple();
  }
  
  float_couple & Typed_value::to_float_couple(){
    return to_Lexem().to_float_couple();
  }
  
  float_triple & Typed_value::to_float_triple(){
    return to_Lexem().to_float_triple();
  }
  
  boolean_couple & Typed_value::to_boolean_couple(){
    return to_Lexem().to_boolean_couple();
  }
  
  boolean_triple & Typed_value::to_boolean_triple(){
    return to_Lexem().to_boolean_triple();
  }
  
  vector<int> & Typed_value::to_int_vector(){
    return to_Vector_type().to_int();
  }
  
  vector<double> & Typed_value::to_float_vector(){
    return to_Vector_type().to_float();
  }
  
  vector<string> & Typed_value::to_string_vector(){
    return to_Vector_type().to_string();
  }
  
  vector<int_couple> & Typed_value::to_int_couple_vector(){
    return to_Vector_type().to_int_couple();
  }
  
  vector<int_triple> & Typed_value::to_int_triple_vector(){
    return to_Vector_type().to_int_triple();
  }
  
  vector<float_couple> & Typed_value::to_float_couple_vector(){
    return to_Vector_type().to_float_couple();
  }
  
  vector<float_triple> & Typed_value::to_float_triple_vector(){
    return to_Vector_type().to_float_triple();
  }
  
}
